Drag and drop

React Bootstrap 5 Drag and drop plugin

Drag and Drop plugin built with Bootstrap 5. Examples of draggable list, cards, tables, grid, buttons. Available sort, copy, scroll, disable, delay, nested & other options.

Note: Read the API tab to find all available options and advanced customization


Draggable basic example

By using MDBDraggable component you can make your custom element draggable.

Drag me!

        
            
            import React from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBDraggable className='shadow-1-strong' draggingClass='shadow-3-strong'>
                  <p>Drag element</p>
                </MDBDraggable>
              );
            }
          
        
    

Custom container

If you want to have your draggable component in a container, add container property with the reference to your element.

Drag me!

        
            
            import React, { useRef } from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              const containerElement = useRef(null);

              return (
                <section ref={containerElement} className='border p-4 mb-4' style={{ height: '400px', overflow: 'hidden' }}>
                  <MDBDraggable className='shadow-1-strong' draggingClass='shadow-3-strong' container={containerElement}>
                    <p>Drag element</p>
                  </MDBDraggable>
                </section>
              );
            }
          
        
    

Blocked axis

Thanks to blockXAxis property or blockYAxis property you can disable x or y axis.

Drag me!

Drag me!

        
            
            import React, { useRef } from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              const blockedElement = useRef(null);

              return (
                <section
                  ref={blockedElement}
                  className='border p-4 d-flex justify-content-center mb-4'
                  style={{ height: '400px', overflow: 'hidden' }}
                >
                  <MDBDraggable
                    blockXAxis
                    className='shadow-1-strong'
                    draggingClass='shadow-3-strong'
                    container={blockedElement}
                  >
                    <p>Drag element</p>
                  </MDBDraggable>

                  <MDBDraggable
                    blockYAxis
                    className='shadow-1-strong'
                    draggingClass='shadow-3-strong'
                    container={blockedElement}
                  >
                    <p>Drag element</p>
                  </MDBDraggable>
                </section>
              );
            }
          
        
    

Delay

You can set delay of starting dragging by adding delay property with miliseconds value.

Drag me after one second!

        
            
            import React from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBDraggable delay={1000} className='shadow-1-strong' draggingClass='shadow-3-strong'>
                  <p>Drag element</p>
                </MDBDraggable>
              );
            }
          
        
    

Disabled

You can set your draggable element as disabled by adding disabled property.

Disabled

        
            
            import React from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBDraggable disabled className='shadow-1-strong' draggingClass='shadow-3-strong'>
                  <p>Drag element</p>
                </MDBDraggable>
              );
            }
          
        
    

Custom drag button

By adding dragHandle with the reference you can set drag handler of your element. Note that drag handler has to be inside an element.

Drag only on button!

        
            
            import React, { useRef } from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              const customDrag = useRef(null);

              return (
                <MDBDraggable dragHandle={customDrag} className='shadow-1-strong' draggingClass='shadow-3-strong'>
                  <i className='fas fa-arrows-alt draggable-drag-ico draggable-cursor-grab' ref={customDrag} />
                  <p>Drag only on button!</p>
                </MDBDraggable>
              );
            }
          
        
    

Scrolling option

When your draggable element is inside a scrollable container your component will scroll its while you will be near the edge.

        
            
            import React, { useRef } from 'react';
            import { MDBDraggable } from 'mdb-react-drag-and-drop';

            export default function App() {
              const scrollableElement = useRef(null);

              return (
                <section ref={scrollableElement} className='border p-4 mb-4' style={{ height: '400px', overflow: 'auto' }}>
                  <MDBDraggable className='shadow-1-strong' draggingClass='shadow-3-strong' container={scrollableElement}>
                    <p>Drag!</p>
                  </MDBDraggable>

                  <div style={{ height: '800px', width: '2000px' }}></div>
                </section>
              );
            }
          
        
    

Sortable basic example

By using MDBSortable you will make your list sortable. Note, only MDBSortableElement elements will be able to sort.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            import React from 'react';
            import { MDBSortable, MDBSortableElement } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBSortable>
                  <MDBSortableElement>Item 1</MDBSortableElement>
                  <MDBSortableElement>Item 2</MDBSortableElement>
                  <MDBSortableElement>Item 3</MDBSortableElement>
                  <MDBSortableElement>Item 4</MDBSortableElement>
                  <MDBSortableElement>Item 5</MDBSortableElement>
                </MDBSortable>
              );
            }
          
        
    

Horizontal example

Sortable list will create no matter how rotated it is.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            import React from 'react';
            import { MDBSortable, MDBSortableElement } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBSortable id='sortable-horizontal' className='d-flex'>
                  <MDBSortableElement>Item 1</MDBSortableElement>
                  <MDBSortableElement>Item 2</MDBSortableElement>
                  <MDBSortableElement>Item 3</MDBSortableElement>
                  <MDBSortableElement>Item 4</MDBSortableElement>
                  <MDBSortableElement>Item 5</MDBSortableElement>
                </MDBSortable>
              );
            }
          
        
    

Grid example

Sortable list works with grid as well.

Item 1
Item 2
Item 3
Item 4
Item 5
Item 6
Item 7
Item 8
Item 9
Item 10
Item 11
Item 12
        
            
            import React from 'react';
            import { MDBSortable, MDBSortableElement } from 'mdb-react-drag-and-drop';

            export default function App() {
              return (
                <MDBSortable id='sortable-grid' className='d-flex flex-wrap'>
                  <MDBSortableElement>Item 1</MDBSortableElement>
                  <MDBSortableElement>Item 2</MDBSortableElement>
                  <MDBSortableElement>Item 3</MDBSortableElement>
                  <MDBSortableElement>Item 4</MDBSortableElement>
                  <MDBSortableElement>Item 5</MDBSortableElement>
                  <MDBSortableElement>Item 6</MDBSortableElement>
                  <MDBSortableElement>Item 7</MDBSortableElement>
                  <MDBSortableElement>Item 8</MDBSortableElement>
                  <MDBSortableElement>Item 9</MDBSortableElement>
                  <MDBSortableElement>Item 10</MDBSortableElement>
                  <MDBSortableElement>Item 11</MDBSortableElement>
                  <MDBSortableElement>Item 12</MDBSortableElement>
                </MDBSortable>
              );
            }
          
        
    
        
            
            #sortable-grid .sortable-item {
              width: 125px;
              height: 125px;
              margin: 15px;
              display: flex;
              justify-content: center;
              border: 1px solid #ccc;
              text-align: center;
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Drag and drop - API


Import

        
            
            import { MDBDraggable, MDBSortable } from 'mdb-react-drag-and-drop';
          
        
    

Properties

MDBDraggable

Name Type Default Description Example
className string '' Adds a custom class to the MDBDraggable <MDBDraggable className="class" />
blockXAxis boolean false Defines whether 'x' axis is blocked or not <MDBDraggable blockXAxis />
blockYAxis boolean false Defines whether 'y' axis is blocked or not <MDBDraggable blockYAxis />
container React.RefObject<any> body Defines container of dragging element <MDBDraggable container={container} />
delay number 0 Defines how long will deley exist before element starts to drag <MDBDraggable delay={500} />
disabled boolean false Defines whether element is able to drag or not <MDBDraggable disabled />
dragHandle React.RefObject<any> Defines drag handler of the element. Note, handler has to be inside of the dragging element <MDBDraggable dragHandle={dragElement} />
draggingClass string dragging Defines class which is using during dragging of the element <MDBDraggable draggingClass='test' />
scrollPixels number 40 If container is scrollable, defines distance from edges where scrolling will begin <MDBDraggable scrollPixels={600} />
tag string 'div' Defines a tag type for the MDBDraggable <MDBDraggable tag='span' />

MDBSortable

Name Type Default Description Example
className string '' Add custom class to the MDBSortable <MDBSortable className="class" />
tag string 'div' Defines a tag type for the MDBSortable <MDBSortable tag='span' />

Drag and drop

Vue Bootstrap 5 Drag and drop plugin

Drag and Drop plugin built with Bootstrap 5 and Vue 3. Examples of draggable list, cards, tables, grid, buttons. Available sort, copy, scroll, disable, delay, nested & other options.

Note: Read the API tab to find all available options and advanced customization


Draggable basic example

Create draggable element with MDBDraggable component.

Drag me!

        
            
            <template>
              <section
                class="border p-4 d-flex justify-content-center mb-4"
                style="height: 400px"
              >
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                >
                  <p>Drag me!</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
            </style>
          
        
    

Custom container

If you want to have your draggable component in a container, just add container property with selector to your component. .

Drag me!

        
            
            <template>
              <section
                class="border p-4 mb-4"
                style="height: 400px; overflow: hidden"
                id="draggable-container"
              >
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                  container="#draggable-container"
                >
                  <p>Drag me!</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
          <style>
            .draggable-element {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }
          </style>
          
        
    

Blocked axis

Thanks to blockXAxis property or blockYAxis property you can disable x or y axis. .

Drag me!

Drag me!

        
            
            <template>
              <section
                class="border p-4 d-flex justify-content-center mb-4"
                style="height: 400px; overflow: hidden"
                id="draggable-container2"
              >
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                  container="#draggable-container2"
                  blockXAxis
                >
                  <p>Drag me!</p>
                </MDBDraggable>
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                  container="#draggable-container2"
                  blockYAxis
                >
                  <p>Drag me!</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
            </style>
          
        
    

Delay

You can set delay of starting dragging by adding delay property with miliseconds value. .

Drag me after one second!

        
            
            <template>
              <section
                class="border p-4 d-flex justify-content-center mb-4"
                style="height: 400px"
              >
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                  :delay="1000"
                >
                  <p>Drag me!</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
            </style>
          
        
    

Disabled

You can set your draggable element as disabled by adding disabled property. .

Disabled

        
            
            <template>
              <section
                class="border p-4 d-flex justify-content-center mb-4"
                style="height: 400px"
              >
                <MDBDraggable class="draggable-element shadow-1-strong" disabled>
                  <p>Disabled</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
            </style>
          
        
    

Custom drag button

By adding dragHandle with selector you can set drag handler of your element. Note that drag handler has to be inside an element.

Drag only on button!

        
            
            <template>
              <section
                class="border p-4 d-flex justify-content-center mb-4"
                style="height: 400px"
              >
                <MDBDraggable
                  class="draggable-element shadow-1-strong"
                  draggingClass="shadow-3-strong"
                  dragHandle=".draggable-drag-ico"
                >
                  <i class="fas fa-arrows-alt draggable-drag-ico"></i>
                  <p>Drag only on button!</p>
                </MDBDraggable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
              .draggable-drag-ico {
                position: absolute;
                top: 10px;
                right: 10px;
                font-size: 1.5rem;
                color: grey;
              }
            </style>
          
        
    

Scrolling option

When your draggable element is inside a scrollable container your component will scroll its while you will be near the edge.

        
            
            <template>
              <section
                class="border p-4 mb-4"
                style="height: 400px; overflow: auto"
                id="draggable-container6"
              >
                <div style="height: 800px; width: 2000px">
                  <MDBDraggable
                    class="draggable-element shadow-1-strong"
                    draggingClass="shadow-3-strong"
                    container="#draggable-container6"
                  >
                    <p>Drag me!</p>
                  </MDBDraggable>
                </div>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBDraggable
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBDraggable } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .draggable-element {
                display: flex;
                width: 200px;
                height: 200px;
                justify-content: center;
                align-items: center;
                background-color: var(--mdb-secondary-bg-subtle);
              }
            </style>
          
        
    

Sortable basic example

Make your list sortable with MDBSortable component and sortable items with MDBSortableItem.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <template>
              <MDBSortable>
                <MDBSortableItem>Item 1</MDBSortableItem>
                <MDBSortableItem>Item 2</MDBSortableItem>
                <MDBSortableItem>Item 3</MDBSortableItem>
                <MDBSortableItem>Item 4</MDBSortableItem>
                <MDBSortableItem>Item 5</MDBSortableItem>
              </MDBSortable>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }
            </style>
          
        
    

Horizontal example

Sortable list will create no matter how rotated it is.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <template>
              <MDBSortable classes="d-flex" id="sortable-horizontal">
                <MDBSortableItem>Item 1</MDBSortableItem>
                <MDBSortableItem>Item 2</MDBSortableItem>
                <MDBSortableItem>Item 3</MDBSortableItem>
                <MDBSortableItem>Item 4</MDBSortableItem>
                <MDBSortableItem>Item 5</MDBSortableItem>
              </MDBSortable>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }
              #sortable-horizontal .sortable-item {
                width: 100%;
                border-bottom: none;
                border-left: 1px solid var(--mdb-secondary-border-subtle);
              }
            </style>
          
        
    

Grid example

Sortable list works with grid as well.

Item 1
Item 2
Item 3
Item 4
Item 5
Item 6
Item 7
Item 8
Item 9
Item 10
Item 11
Item 12
        
            
            <template>
              <MDBSortable classes="d-flex flex-wrap" id="sortable-grid">
                <MDBSortableItem>Item 1</MDBSortableItem>
                <MDBSortableItem>Item 2</MDBSortableItem>
                <MDBSortableItem>Item 3</MDBSortableItem>
                <MDBSortableItem>Item 4</MDBSortableItem>
                <MDBSortableItem>Item 5</MDBSortableItem>
                <MDBSortableItem>Item 6</MDBSortableItem>
                <MDBSortableItem>Item 7</MDBSortableItem>
                <MDBSortableItem>Item 8</MDBSortableItem>
                <MDBSortableItem>Item 9</MDBSortableItem>
                <MDBSortableItem>Item 10</MDBSortableItem>
                <MDBSortableItem>Item 11</MDBSortableItem>
                <MDBSortableItem>Item 12</MDBSortableItem>
              </MDBSortable>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }

              #sortable-grid .sortable-item {
                width: 125px;
                height: 125px;
                margin: 15px;
                display: flex;
                justify-content: center;
                border: 1px solid var(--mdb-secondary-border-subtle);
                text-align: center;
              }
            </style>
          
        
    

Multiple tables

You can connect your list with other by passing its reference to the connectedList property.

To do

Item 1
Item 2
Item 3
Item 4
Item 5
Disabled

Done

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <template>
              <section class="p-4 d-flex justify-content-center w-100">
                <MDBSortable
                  ref="sortableMultiTables1"
                  id="sortable-multi-tables-1"
                  :connectedList="sortableMultiTables2"
                >
                  <h4 class="text-center pt-2">To do</h4>
                  <MDBSortableItem>Item 1</MDBSortableItem>
                  <MDBSortableItem>Item 2</MDBSortableItem>
                  <MDBSortableItem>Item 3</MDBSortableItem>
                  <MDBSortableItem>Item 4</MDBSortableItem>
                  <MDBSortableItem>Item 5</MDBSortableItem>
                  <MDBSortableItem disabled>Disabled</MDBSortableItem>
                </MDBSortable>
                <MDBSortable
                  ref="sortableMultiTables2"
                  id="sortable-multi-tables-2"
                  :connectedList="sortableMultiTables1"
                >
                  <h4 class="text-center pt-2">Done</h4>
                  <MDBSortableItem>Item 6</MDBSortableItem>
                  <MDBSortableItem>Item 7</MDBSortableItem>
                  <MDBSortableItem>Item 8</MDBSortableItem>
                  <MDBSortableItem>Item 9</MDBSortableItem>
                  <MDBSortableItem>Item 10</MDBSortableItem>
                </MDBSortable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
                setup() {
                  const sortableMultiTables1 = ref(null);
                  const sortableMultiTables2 = ref(null);
                  return {
                    sortableMultiTables1,
                    sortableMultiTables2,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";

              const sortableMultiTables1 = ref();
              const sortableMultiTables2 = ref();
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }
            </style>
          
        
    

Coping items

By adding copy property you can copy your items to connected table.

Elements

Item 1
Item 2
Item 3
Item 4
Item 5

Copy

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <template>
              <section class="p-4 d-flex justify-content-center w-100">
                <MDBSortable
                  ref="sortableCopy1"
                  id="sortable-copy-1"
                  :connectedList="sortableCopy2"
                  :sorting="false"
                  copy
                >
                  <h4 class="text-center pt-2">Element</h4>
                  <MDBSortableItem>Item 1</MDBSortableItem>
                  <MDBSortableItem>Item 2</MDBSortableItem>
                  <MDBSortableItem>Item 3</MDBSortableItem>
                  <MDBSortableItem>Item 4</MDBSortableItem>
                  <MDBSortableItem>Item 5</MDBSortableItem>
                  <MDBSortableItem>Item 11</MDBSortableItem>
                </MDBSortable>
                <MDBSortable
                  ref="sortableCopy2"
                  id="sortable-copy-2"
                  :connectedList="sortableCopy1"
                >
                  <h4 class="text-center pt-2">Copy</h4>
                  <MDBSortableItem>Item 6</MDBSortableItem>
                  <MDBSortableItem>Item 7</MDBSortableItem>
                  <MDBSortableItem>Item 8</MDBSortableItem>
                  <MDBSortableItem>Item 9</MDBSortableItem>
                  <MDBSortableItem>Item 10</MDBSortableItem>
                </MDBSortable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
                setup() {
                  const sortableCopy1 = ref(null);
                  const sortableCopy2 = ref(null);
                  return {
                    sortableCopy1,
                    sortableCopy2,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";

              const sortableCopy1 = ref();
              const sortableCopy2 = ref();
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }              
            </style>
          
        
    

Conditions

You can set your own conditions about permission to sending or coping items to connected table by adding your custom function with true / false return to enterPredicate property.

Numbers

1
2
3
4
5

Only odd numbers

7
        
            
            <template>
              <section class="p-4 d-flex justify-content-center w-100">
                <MDBSortable
                  :enterPredicate="accessOddNumbers"
                  ref="sortableCondition1"
                  :connectedList="sortableCondition2"
                  id="sortable-condition-1"
                >
                  <h4 class="text-center pt-2">Numbers</h4>
                  <MDBSortableItem :value="1">1</MDBSortableItem>
                  <MDBSortableItem :value="2">2</MDBSortableItem>
                  <MDBSortableItem :value="3">3</MDBSortableItem>
                  <MDBSortableItem :value="4">4</MDBSortableItem>
                  <MDBSortableItem :value="5">5</MDBSortableItem>
                </MDBSortable>
                <MDBSortable
                  ref="sortableCondition2"
                  :connectedList="sortableCondition1"
                  id="sortable-condition-2"
                >
                  <h4 class="text-center pt-2">Only odd numbers</h4>
                  <MDBSortableItem :value="7">7</MDBSortableItem>
                </MDBSortable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
                setup() {
                  const sortableCondition1 = ref(null);
                  const sortableCondition2 = ref(null);
                  const accessOddNumbers = (value) => {
                    return parseInt(value) % 2;
                  };
                  return {
                    sortableCondition1,
                    sortableCondition2,
                    accessOddNumbers
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";

              const sortableCondition1 = ref();
              const sortableCondition2 = ref();
              const accessOddNumbers = (value: string) => {
                return parseInt(value) % 2;
              };
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }

              #sortable-condition-1,
              #sortable-condition-2 {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }
            </style>
          
        
    

Disabled sorting

By adding sorting with false value you can disable sorting in table.

Sorting available

Item 1
Item 2
Item 3
Item 4
Item 5

Sorting not available

item 6
item 7
        
            
            <template>
              <section class="p-4 d-flex justify-content-center w-100">
                <MDBSortable
                  id="sortable-disabled-1"
                  ref="sortableDisabled1"
                  :connectedList="sortableDisabled2"
                >
                  <h4 class="text-center pt-2">Sorting available</h4>
                  <MDBSortableItem>Item 1</MDBSortableItem>
                  <MDBSortableItem>Item 2</MDBSortableItem>
                  <MDBSortableItem>Item 3</MDBSortableItem>
                  <MDBSortableItem>Item 4</MDBSortableItem>
                  <MDBSortableItem>Item 5</MDBSortableItem>
                </MDBSortable>
                <MDBSortable
                  id="sortable-disabled-2"
                  ref="sortableDisabled2"
                  :connectedList="sortableDisabled1"
                  :sorting="false"
                >
                  <h4 class="text-center pt-2">Sorting not available</h4>
                  <MDBSortableItem>item 6</MDBSortableItem>
                  <MDBSortableItem>item 7</MDBSortableItem>
                </MDBSortable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
                setup() {
                  const sortableDisabled1 = ref(null);
                  const sortableDisabled2 = ref(null);
                  return {
                    sortableDisabled1,
                    sortableDisabled2,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";

              const sortableDisabled1 = ref();
              const sortableDisabled2 = ref();
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }
            </style>
          
        
    

Nested

By adding itemClass you can set what class has to be in your list item to make them sortable. Thanks to that you can make nested lists.

To do

Item 1
Item 2
Item 3
Item 4
Item 5

Done

item 6
item 7
item 8
item 9
        
            
            <template>
              <section class="p-4 d-flex justify-content-center w-100">
                <MDBSortable
                  id="sortable-multi-1-1"
                  classes="d-flex align-items-start"
                  itemClass="sortable-item-nested"
                >
                  <MDBSortable
                    id="sortable-multi-2-2"
                    ref="sortableMulti1"
                    classes="sortable-item-nested"
                    :connectedList="sortableMulti2"
                    dragHandle=".drag-handler"
                  >
                    <h4 class="text-center pt-2 drag-handler">To do</h4>
                    <MDBSortableItem>Item 1</MDBSortableItem>
                    <MDBSortableItem>Item 2</MDBSortableItem>
                    <MDBSortableItem>Item 3</MDBSortableItem>
                    <MDBSortableItem>Item 4</MDBSortableItem>
                    <MDBSortableItem>Item 5</MDBSortableItem>
                  </MDBSortable>
                  <MDBSortable
                    id="sortable-multi-2-1"
                    ref="sortableMulti2"
                    classes="sortable-item-nested"
                    :connectedList="sortableMulti1"
                    dragHandle=".drag-handler"
                  >
                    <h4 class="text-center pt-2 drag-handler">Done</h4>
                    <MDBSortableItem>item 6</MDBSortableItem>
                    <MDBSortableItem>item 7</MDBSortableItem>
                    <MDBSortableItem>item 8</MDBSortableItem>
                    <MDBSortableItem>item 9</MDBSortableItem>
                  </MDBSortable>
                </MDBSortable>
              </section>
            </template>
          
        
    
        
            
            <script>
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";
              export default {
                components: {
                  MDBSortable,
                  MDBSortableItem
                },
                setup() {
                  const sortableMulti1 = ref(null);
                  const sortableMulti2 = ref(null);
                  return {
                    sortableMulti1,
                    sortableMulti2,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBSortable, MDBSortableItem } from "mdb-vue-drag-and-drop";
              import { ref } from "vue";

              const sortableMulti1 = ref();
              const sortableMulti2 = ref();
            </script>
          
        
    
        
            
            <style>
              .sortable-list {
                width: 500px;
                max-width: 100%;
                border: solid 1px var(--mdb-secondary-border-subtle);
                min-height: 60px;
                display: block;
                background: var(--mdb-secondary-bg-subtle);
                border-radius: 4px;
              }

              .sortable-item {
                padding: 20px 10px;
                border-bottom: solid 1px var(--mdb-secondary-border-subtle);
                color: var(--mdb-body-color);
                background: var(--mdb-secondary-bg-subtle);
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: space-between;
                user-select: none;
              }
            </style>
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Drag and drop - API


Import

        
            
          <script>
            import { 
              MDBDraggable, 
              MDBSortable, 
              MDBSortableItem 
            } from "mdb-vue-drag-and-drop";
          </script>
        
        
    

Properties

Draggable

Name Type Default Description
blockXAxis Boolean false Defines whether 'x' axis is blocked or not
blockYAxis Boolean false Defines whether 'y' axis is blocked or not
container String body Defines container of dragging element
delay Number 0 Defines how long will deley exist before element starts to drag
disabled Boolean false Defines whether element is able to drag or not
disabled Boolean false Defines whether element is able to drag or not
dragHandle String '' Defines drag handler of the element. Note, handler has to be inside of the dragging element
draggingClass String dragging Defines class which is using during dragging of the element
scrollPixels Number 40 If container is scrollable, defines distance from edges where scrolling will begin
tag Stering 'div' Defines element tag

Sortable

Name Type Default Description
animationDuration Number 300 Defines duration of sliding and returning animations
blockXAxis Boolean false Defines whether 'x' axis is blocked or not
blockYAxis Boolean false Defines whether 'y' axis is blocked or not
classes String '' Defines custom classes for sortable list wrapper
connectedList Ref element null Defines list which you want to connect with
copy Boolean false Defines whether you want to copy elements from one list to another or send them instead
dragHandle String '' Defines drag handler of the element for nested lists. Note, handler has to be inside of the dragging element
enterPredicate Function () => true Defines function which check access between tables
itemClass String sortable-item Defines class name for sortable items.
sorting Boolean true Defines whether list is able to sort or not
tag Stering 'div' Defines element tag

Sortable Item

Name Type Default Description
blockXAxis Boolean false Defines whether 'x' axis is blocked or not
blockYAxis Boolean false Defines whether 'y' axis is blocked or not
disabled Boolean false Defines whether element is allowed to drag or not
classes String '' Defines custom classes for sortable list wrapper
dragHandle String '' Defines drag handler of the element. Note, handler has to be inside of the dragging element
itemClass String sortable-item Defines class name for sortable items.
value String , Number Defines custom value for access between lists
tag Stering 'div' Defines element tag

Methods

Draggable

Name Description
resetPosition Return original position of the element
        
            
          <template>
            <section
              class="border p-4 d-flex justify-content-center mb-4"
              style="height: 400px"
            >
              <MDBDraggable
                class="draggable-element shadow-1-strong"
                draggingClass="shadow-3-strong"
                ref="draggableRef"
              >
                <p>Drag me!</p>
              </MDBDraggable>
            </section>
            <div><MDBBtn @click="resetPosition">Reset position</MDBBtn></div>
          </template>
        
        
    
        
            
        <script>
          import { 
            MDBDraggable, 
          } from "mdb-vue-drag-and-drop";
          import {
            MDBBtn
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          export default {
            components: {
              MDBDraggable,
              MDBBtn,
            },
            setup() {
              const draggableRef = ref(null);
              const resetPosition = () => draggableRef.value.resetPosition();
          
              return {
                draggableRef,
                resetPosition
              };
            },
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { 
            MDBDraggable, 
          } from "mdb-vue-drag-and-drop";
          import {
            MDBBtn
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          const draggableRef = ref<InstanceType<typeof MDBDraggable> | null>(null);
          const resetPosition = () => draggableRef.value?.resetPosition();
        </script>
        
        
    

Sortable

Name Description
addItem Adds element to the sortable list. You can set position in the list of your new item by adding index number. Note: If you did not insert an index number, your element would append at the end of the list.
        
            
          <template>
            <section class="border p-4 d-flex justify-content-center mb-4">
              <MDBSortable ref="sortableRef">
                <MDBSortableItem v-for="item in list" :key="item.id">{{
                  item.name
                }}</MDBSortableItem>
              </MDBSortable>
              <div><MDBBtn @click="addElement">Add</MDBBtn></div>
            </section>
          </template>
        
        
    
        
            
        <script>
          import { 
            MDBSortable,
            MDBSortableItem 
          } from "mdb-vue-drag-and-drop";
          import {
            MDBBtn
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          export default {
            components: {
              MDBSortable,
              MDBSortableItem 
              MDBBtn,
            },
            setup() {
              const list = ref([
                { id: 0, name: "name 0" },
                { id: 1, name: "name 1" },
                { id: 2, name: "name 2" },
                { id: 3, name: "name 3" },
              ]);

              const sortableRef = ref(null);

              const addElement = () => {
                const item = document.createElement("div");

                item.textContent = "added " + new Date().getMilliseconds();
                item.className = "sortable-item";

                sortableRef.value.addItem(item);
              };
          
              return {
                list,
                sortableRef,
                addElement
              };
            },
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { 
            MDBSortable,
            MDBSortableItem 
          } from "mdb-vue-drag-and-drop";
          import {
            MDBBtn
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          const stepperRef = ref(null);
          const list = ref([
              { id: 0, name: "name 0" },
              { id: 1, name: "name 1" },
              { id: 2, name: "name 2" },
              { id: 3, name: "name 3" },
            ]);

            const sortableRef = ref<InstanceType<typeof MDBSortable> | null>(null);

            const addElement = () => {
              const item = document.createElement("div");

              item.textContent = "added " + new Date().getMilliseconds();
              item.className = "sortable-item";

              sortableRef.value?.addItem(item);
            };
        </script>
        
        
    

Events

Draggable

Name Description
start Emitted when an element is started dragging
end Emitted when an element is ended dragging
move Emitted when an element is dragging
        
            
        <template>
          <section
            class="border p-4 d-flex justify-content-center mb-4"
            style="height: 400px"
          >
            <MDBDraggable
              class="draggable-element shadow-1-strong"
              draggingClass="shadow-3-strong"
              @start="doSomething"
            >
              <p>Drag me!</p>
            </MDBDraggable>
          </section>
        </template>
        
        
    

Sortable

Name Description
move Emitted when one of the itmes from list changed its position.
exit Emitted when one of the items from list will enter to connected table.
start Emitted when one of the items from list is dragged.
end Emitted when dragging one of the items from list have been ended. A new structure of list is available with HTML node which is property of the event.
        
            
          <template>
            <MDBSortable @move="doSomething">...</MDBSortable>
          </template>

Drag and drop

Angular Bootstrap 5 Drag and drop plugin

Drag and Drop plugin built with Bootstrap 5. Examples of draggable list, cards, tables, grid, buttons. Available sort, copy, scroll, disable, delay, nested & other options.

Note: Read the API tab to find all available options and advanced customization


Draggable basic example

By adding mdbDraggable directive you can make your custom element draggable.

Drag me!

        
            
            <div mdbDraggable class="draggable shadow-1-strong">
              <p>Drag me!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Custom container

If you want to have your draggable component in a container, just add boundaryElement directive with selector to your component.

Drag me!

        
            
            <section
              #draggableContainer
              class="border p-4 mb-4"
              style="height: 400px; overflow: hidden;"
            >
              <div mdbDraggable class="draggable shadow-1-strong" [boundaryElement]="draggableContainer">
                <p>Drag me!</p>
              </div>
            </section>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Blocked axis

Thanks to [lockAxis] input you can disable x or y axis.

Drag me!

Drag me!

        
            
            <div mdbDraggable class="draggable shadow-1-strong" [lockAxis]="'x'">
              <p>Drag me!</p>
            </div>
            <div mdbDraggable class="draggable shadow-1-strong" [lockAxis]="'y'">
              <p>Drag me!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Delay

You can set deley of starting dragging by adding [delay] input with miliseconds value.

Drag me after one second!

        
            
            <div mdbDraggable [delay]="1000" class="draggable shadow-1-strong">
              <p>Drag me after one second!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Disabled

You can set your draggable element as disabled by adding [disabled] with true value.

Disabled

        
            
            <div mdbDraggable [disabled]="true" class="draggable shadow-1-strong">
              <p>Disabled</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Custom drag button

By adding [handle] input with element or element selector you can set drag handler of your element. Note that drag handler has to be inside an element.

Drag only on button!

        
            
            <div mdbDraggable [handle]="handle" class="draggable shadow-1-strong">
              <i #handle class="fas fa-arrows-alt draggable-drag-ico"></i>
              <p>Drag only on button!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
              position: relative;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }

            .draggable-drag-ico {
              position: absolute;
              top: 10px;
              right: 10px;
              font-size: 1.5rem;
              color: grey;
            }
          
        
    

Scrolling option

When your draggable element is inside a scrollable container your component will scroll its while you will be near the edge.

        
            
            <div mdbDraggable [autoScroll]="true" class="draggable shadow-1-strong">
              <p>Drag!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: var(--mdb-secondary-bg-subtle);
              position: relative;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }

            .draggable-drag-ico {
              position: absolute;
              top: 10px;
              right: 10px;
              font-size: 1.5rem;
              color: grey;
            }
          
        
    

Sortable basic example

By adding mdbSortableContainer directive you can add sortable functionality to the items in a container. Note, only elements with mdbDraggable directive name will be able to sort.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <div mdbSortableContainer class="sortable-list" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' }
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Horizontal example

Sortable list will create no matter how rotated it is.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <div mdbSortableContainer class="sortable-list d-flex" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' }
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              width: 100%;
              border-bottom: none;
              border-left: 1px solid var(--mdb-secondary-border-subtle);
              border-right 1px solid var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Grid example

Sortable list works with grid as well.

Item 1
Item 2
Item 3
Item 4
Item 5
Item 6
Item 7
Item 8
Item 9
Item 10
Item 11
Item 12
        
            
            <div mdbSortableContainer class="sortable-list d-flex flex-wrap" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' },
                { name: 'Item 6' },
                { name: 'Item 7' },
                { name: 'Item 8' },
                { name: 'Item 9' },
                { name: 'Item 10' },
                { name: 'Item 11' },
                { name: 'Item 12' },
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              justify-content: center;
              align-items: center;
              width: 125px;
              height: 125px;
              margin: 15px;
              border: 1px solid var(--mdb-secondary-border-subtle);
              text-align: center;
              user-select: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Multiple tables

By using [containers] input you can connect your list with other container.

To do

Item 1
Item 2
Item 3
Item 4
Item 5
Disabled

Done

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">To do</h4>
                <div mdbDraggable [disabled]="item.disabled" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Done</h4>
                <div mdbDraggable [disabled]="item.disabled" *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', disabled: false },
                { name: 'Item 2', disabled: false },
                { name: 'Item 3', disabled: false },
                { name: 'Item 4', disabled: false },
                { name: 'Item 5', disabled: false },
                { name: 'Disabled', disabled: true }
              ];

              itemsSecond = [
                { name: 'Item 6', disabled: false },
                { name: 'Item 7', disabled: false },
                { name: 'Item 8', disabled: false },
                { name: 'Item 9', disabled: false },
                { name: 'Item 10', disabled: false }
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Coping items

By adding [copy] input with value true you can copy your items to connected table.

Elements

Item 1
Item 2
Item 3
Item 4
Item 5

Copy

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Elements</h4>
                <div mdbDraggable [copy]="item.copy" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Copy</h4>
                <div mdbDraggable *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, copyItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', copy: true },
                { name: 'Item 2', copy: true },
                { name: 'Item 3', copy: true },
                { name: 'Item 4', copy: true },
                { name: 'Item 5', copy: true },
              ];

              itemsSecond = [
                { name: 'Item 6' },
                { name: 'Item 7' },
                { name: 'Item 8' },
                { name: 'Item 9' },
                { name: 'Item 10' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  copyItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Conditions

You can set your own conditions about permission to sending or coping items to connected table by adding your custom function with true / false return to [enterPredicate] input.

Numbers

1
2
3
4
5

Only odd numbers

7
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Numbers</h4>
                <div mdbDraggable [data]="item.data" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" [enterPredicate]="enterPredicate" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Only odd numbers</h4>
                <div mdbDraggable [data]="item.data" *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent, MdbDraggableDirective } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', data: '1' },
                { name: 'Item 2', data: '2' },
                { name: 'Item 3', data: '3' },
                { name: 'Item 4', data: '4' },
                { name: 'Item 5', data: '5' },
              ];

              itemsSecond = [
                { name: 'Item 7', data: '7' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }

              enterPredicate(item: MdbDraggableDirective) {
                return item.data % 2 !== 0;
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Disabled sorting

By setting sorting input to false you can disable sorting in table.

Sorting available

Item 1
Item 2
Item 3
Item 4
Item 5

Sorting not available

item 6
item 7
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Sorting available</h4>
                <div mdbDraggable *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" [sortingDisabled]="true" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Sorting disabled</h4>
                <div mdbDraggable *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' },
              ];

              itemsSecond = [
                { name: 'Item 6' },
                { name: 'Item 7' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Nested

To do

Item 1
Item 2
Item 3
Item 4
Item 5

Done

item 6
item 7
item 8
item 9
        
            
            <div
              id="sortable-multi-1-1"
              class="sortable-list d-flex align-items-start"
              mdbSortableContainer
              [data]="nestedContainers"
              (itemDrop)="onDrop($event)"
            >
              <div
                *ngFor="let container of nestedContainers"
                class="sortable-list sortable-item-nested"
                mdbSortableContainer
                [id]="container.id"
                [data]="container.data"
                [containers]="getConnectedContainers(container.id)"
                mdbDraggable
                (itemDrop)="onDrop($event)"
              >
                <h4 class="text-center pt-2 drag-handler">{{ container.name }}</h4>
                <div mdbDraggable *ngFor="let item of container.data" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              nestedContainers = [
                {
                  id: 'nested-sortable-1',
                  name: 'To do',
                  data: [
                    { name: 'Item 1' },
                    { name: 'Item 2' },
                    { name: 'Item 3' },
                    { name: 'Item 4' },
                    { name: 'Item 5' },
                  ],
                },
                {
                  id: 'nested-sortable-2',
                  name: 'Done',
                  data: [{ name: 'Item 6' }, { name: 'Item 7' }, { name: 'Item 8' }, { name: 'Item 9' }],
                },
              ];

              getConnectedContainers(id: string) {
                return this.nestedContainers.filter((container) => container.id !== id).map((container) => container.id);
              }

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: 1px solid var(--mdb-secondary-border-subtle);
              min-height: 60px;
              display: block;
              background: var(--mdb-secondary-bg-subtle);
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px var(--mdb-secondary-border-subtle);
              color: var(--mdb-body-color);
              background: var(--mdb-secondary-bg-subtle);
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Drag and drop - API


Installation

To install and configure the plugin follow our Plugins Installation Guide. Please remember to update all the plugin names and import paths. You can find all the necessary information in the Import section.

        
            
     npm i git+https://oauth2:ACCESS_TOKEN@git.mdbootstrap.com/mdb/angular/mdb5/plugins/prd/drag-and-drop
     
        
    

Import

        
            
          import { MdbDragAndDropModule } from 'mdb-angular-drag-and-drop';
          …
          @NgModule ({
            ...
            imports: [MdbDragAndDropModule],
            ...
          })
        
        
    
        
            
        @import 'mdb-angular-drag-and-drop/scss/drag-and-drop.scss';
      
        
    

Inputs

MdbDraggableDirective

Name Type Default Description
boundaryElement HTMLElement | String body Defines boundary container for dragged element
copy Boolean false Defines if dragged element should be moved or copied to new container
data any - Defines draggable element data
delay Number 0 Defines how long will deley exist before element starts to drag
disabled Boolean false Defines whether element is able to drag or not
handle HTMLElement | String - Defines drag handler of the element. Note, handler has to be inside of the dragging element
lockAxis 'x' | 'y' | null null Defines whether 'x' or 'y' axis is blocked

MdbSortableContainerDirective

Name Type Default Description
containers MdbSortableContainer | String [] Defines list of connected containers
enterPredicate Function () => true Defines function which check access between tables
sortingDisabled Boolean false Defines whether list is able to sort or not

Outputs

MdbDraggableDirective

Name Type Description
dragStart EventEmitter<HTMLElement> Emitted on drag start.
dragEnd EventEmitter<HTMLElement> Emitted on drag end.
        
            
            <section class="border p-4 d-flex justify-content-center mb-4" style="height: 400px">
              <div
                mdbDraggable
                (dragStart)="onDragStart($event)"
                class="draggable-element shadow-1-strong"
              >
                <p>Drag me!</p>
              </div>
            </section>                                      
            
        
    
        
            
            import { Component } from '@angular/core';
            
            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              onDragStart(target: HTMLElement) {
                console.log('drag started:', target);
              }
            }                                       
            
        
    

MdbSortableContainerDirective

Name Type Description
itemDrop EventEmitter<MdbDropEvent> Emitted on element drop in container
        
            
            <section class="border p-4 d-flex justify-content-center mb-4">
              <div mdbSortableContainer class="sortable-list" (itemDrop)="onDrop($event)">
                <div mdbDraggable class="sortable-item" *ngFor="let item of items">
                  {{ item.name }}
                </div>
              </div>
            </section>                                    
            
        
    
        
            
            import { Component } from '@angular/core';
            import { MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
              { name: 'Item 1' },
              { name: 'Item 2' },
              { name: 'Item 3' },
              { name: 'Item 4' },
              { name: 'Item 5' },
            ];

            onDrop(event: MdbDropEvent) {
              console.log('item dropped', event)
            }
            }                                       
            
        
    

Advanced types

MdbDropEvent

        
            
            interface MdbDropEvent {
              item: MdbDraggableDirective;
              previousContainer: MdbSortableContainerDirective;
              newContainer: MdbSortableContainerDirective;
              previousIndex: number;
              newIndex: number;
            }